Package page doesn't show related PPAs for that package

Bug #280958 reported by Matthew Paul Thomas
30
This bug affects 2 people
Affects Status Importance Assigned to Milestone
Launchpad itself
Fix Released
High
Michael Nelson

Bug Description

<https://launchpad.net/~ted/+archive/ppa> shows that Ted Gould has a PPA containing a fast-user-switch-applet package for Ubuntu. But this fact is not mentioned on <https://launchpad.net/ubuntu/+source/fast-user-switch-applet>. It should be mentioned as a side-point.

One way of doing this would be to have a "Personal package archives" section after the "Published versions and upstream associations" section on the package page.

Bug 224196 is the equivalent for the project page.

This PPA section should:
1) clearly identify the listed PPAs as *untrusted* and *unsupported*
2) not appear as part of the core information of the page, but rather be clearly identified as additional *related* information,
3) display at most 3 archives (eventually by rank, but for now those with latest publishings), and link to a page where more can be found (eventually a custom page, but for now the PPA package search page)

There has been a lot of discussion so far, and we seem to have narrowed down to one option (if any at the current time):

http://launchpadlibrarian.net/28624082/ppas-in-packages.ogv
(wording has been updated slightly from this demo video.)
Pros: It's much less obtrusive, clearly indicates the order.
Cons: Still suffers from the one remaining issue - random PPAs being having the latest uploads.

A slightly re-worded version of the above should be on Edge by the end of 2009-07-03.

The current feeling seems to be that, without an option to return the three PPAs with the highest rank (yet), this feature might not be worth the pain it causes people like Fabien (maintainer of FF3.5). In its current form the 3 ppas with the *latest uploads* are displayed - as without a rank, this is the best alternative we could find. We have updated the text to try to indicate this clearly so that there is no rank implied etc., but it still can seem very random (and usually not what the user is after in the case of FF3.5).

Fabien has one idea, to only display PPAs that are owned by teams/people who are members of the upstream project - which might be a good intermediate solution.

If we don't get a good intermediate solution, a decision will need to be made whether to revert this feature on Edge before 2.2.7 closes.

Tags: lp-soyuz
description: updated
Revision history for this message
Julian Edwards (julian-edwards) wrote :

An interesting change worth doing at some point I think.

Changed in soyuz:
status: New → Triaged
Revision history for this message
Scott Kitterman (kitterman) wrote :

I think this would make even worse the current problems we have with users being confused with what is an Ubuntu package and what is not. Please don't do this. https://launchpad.net/ubuntu/+source/fast-user-switch-applet is a link to the Ubuntu package and to list packages that are not part of Ubuntu would be wrong.

Revision history for this message
Julian Edwards (julian-edwards) wrote :

This is a good idea, provided that it's plainly obvious that we're listing PPAs and that they're unofficial packages. Martin, we talked about getting some PPA branding and icons, did that get anywhere?

Changed in soyuz:
assignee: nobody → michael.nelson
importance: Undecided → Medium
milestone: none → 2.2.4
Changed in soyuz:
milestone: 2.2.4 → 2.2.5
Changed in soyuz:
importance: Medium → High
milestone: 2.2.5 → 2.2.6
Revision history for this message
Scott Kitterman (kitterman) wrote : Re: [Bug 280958] Re: Package page doesn't show PPAs for that package

Since https://launchpad.net/ubuntu/+source/fast-user-switch-applet is about
Ubuntu packages and PPA packages are not part of Ubuntu, I think it's
entirely appropriate that they are not listed. Changing this risks
dilution of the Ubuntu brand and may represent a security risk since having
a PPA package appear in the Ubuntu namespace would probably make social
engineering attacks easier to execute.

Revision history for this message
Christian Reis (kiko) wrote : Re: Package page doesn't show PPAs for that package

Scott, you're right that there is a risk of confusion, but there are ways of presenting this information in a manner that wouldn't give people the wrong message. Let's see what a mockup of this would look like and then make a call of whether or not it's going to be confusing.

Revision history for this message
Scott Kitterman (kitterman) wrote : Re: [Bug 280958] Re: Package page doesn't show PPAs for that package

I'm fine with that. We just need to proceed carefully. We had some
discussions around similar issues with Ivanka (Ayatana) at UDS. It is
probably worth engaging her/her team and Ubuntu security in the discussion.

Revision history for this message
Julian Edwards (julian-edwards) wrote : Re: [Bug 280958] Re: Package page doesn't show PPAs for that package

Scoptt, one of her team members, Martin Albisetti, oversees all our UI changes
anyway, so I'll make sure he gets involved early in any design.

Revision history for this message
Michael Nelson (michael.nelson) wrote : Re: Package page doesn't show PPAs for that package

Martin, have you got time to do some mockups for how this could be done safely?

My own opinion is that while it might be ok to show a preview of the first few ppas with this package (clearly identified and, in the future, ranked), it should just be a preview with a link to a separate page where they really belong and where the full ppa results could be batched etc. (as in the future there could be lots of ppas matching a given package). So something like:

"There are also some unsupported versions of 'rabbitmq-server' from the community such as:
  * example 1
  * example 2
  * example 3
You can view <link>all the unsupported PPA versions of 'rabbitmq-server'</link>"

The current PPA search page provides the results, but not in the format a user in this scenario would be after:

https://edge.launchpad.net/ubuntu/+ppas?name_filter=rabbitmq-server

Also, given that the original links now 404, here's some new example links:

* Celso's PPA with rabbitmq-server:
https://edge.launchpad.net/~cprov/+archive/ppa

* Same package in Ubuntu:
https://edge.launchpad.net/ubuntu/+source/rabbitmq-server

Revision history for this message
Michael Nelson (michael.nelson) wrote :

OK, I've just been chatting with Martin about this and he had similar thoughts to mine above, so if you've got any feedback, please provide it now :). The idea would be, directly under the "Published versions and upstream associations" table we'd have something like:

"""
There are also some unsupported external versions of 'rabbitmq-server' from the community in the following PPAs:

Table with headings: PPA Name (owner) | PPA Description (first 10 words?) | Versions
Row 1: Official rabbitmq-server nightly builds (rabbitmq-team) | This is the rabbitmq-server team ... | karmic (1.5.5-0ubuntu1ppa0), jaunty (1.5.4-0ubuntu1ppa4)
Row 2: PPA of Joe Blogs (joe-blogs) | My experimental PPA | karmic (1.5.5-0ubuntu5wrong

You can view <link>all the unsupported external PPA versions of 'rabbitmq-server'</link>
"""

Currently we don't necessarily need to limit the results as we don't have that many, but we should create a bug to limit by rank (when we have ppa rankings of some kind). If it's easy, we could limit it to 3 ordered by most-recent upload.

For the moment, the link to view PPA's with that package will simply go to the ppa search page for that package (eg. https://edge.launchpad.net/ubuntu/+ppas?name_filter=rabbitmq-server), but we can create a bug to update this later to it's own ppa packages page with more relevant information.

Revision history for this message
Scott Kitterman (kitterman) wrote : Re: [Bug 280958] Re: Package page doesn't show PPAs for that package

My suggestion is don't do it at all as it encourages Ubuntu users to
install software from untrusted sources and dilutes the Ubuntu name. These
PPAs are not related to the Ubuntu distro.

Revision history for this message
Martin Albisetti (beuno) wrote : Re: Package page doesn't show PPAs for that package

I think that is a very short-sighted way of looking at it, as well as ignoring reality, where users install random software anyway.
If we manage to centralize this a bit more, and apply quality filters on top of it, we will have improved the situation rather than making it worst.
Software moves much faster than 6 month cycles, and PPAs address a lot of this gray area.

I fully understand your concerns, I agree with them and appreciate the feedback, but strongly disagree with the solution (or lack of) you propose.
This was discussed at UDS several times, and the general agreement is that we have to address this somehow and stop avoiding the reality of what users do.

Revision history for this message
Scott Kitterman (kitterman) wrote : Re: [Bug 280958] Re: Package page doesn't show PPAs for that package

I understand that, I can see having a listing, just not in the distro
namespace.

Revision history for this message
Matthew Paul Thomas (mpt) wrote : Re: Package page doesn't show PPAs for that package

I'm highly skeptical that Launchpad developers would ever get around to implementing "quality filters on top of it". Fortunately, however, Launchpad is not for Ubuntu end users, it is for developers and testers. To lower the barrier to entry for project developers, Launchpad project Code pages list all active branches of the project that Launchpad knows about, regardless of whether they were created by official project developers or by anyone else. Listing PPA packages on an Ubuntu package page would be the direct package equivalent of that.

Changed in soyuz:
milestone: 2.2.6 → 2.2.7
status: Triaged → In Progress
Revision history for this message
Michael Nelson (michael.nelson) wrote :

Attaching the original implementation of our discussion above.

Feedback from Martin was that it looks too much like it's part of the page and that we should perhaps try a list instead of a table, as well as shorten the text (so there's more chance of it being read).

Revision history for this message
Michael Nelson (michael.nelson) wrote :

This second version is the list-version of the latest PPAs.

IMO it still looks like it's part of the page, rather than informational, which is why I've created a third version...

Revision history for this message
Michael Nelson (michael.nelson) wrote :

This third version simply adds the blue-fade-to-gray background... trying to imply that it is a related informational message.

It's just an idea - it would need to be refined - but I'll wait for further input from you Martin.

Revision history for this message
Michael Nelson (michael.nelson) wrote :

Here's a fourth with some improvements from Julian:

1) Subtle gray background
2) Uses new PPA icon for the box (we can add the link ppa-icons in a separate branch)

I've set the width to 80% and then used the other settings of .informational.message.

Revision history for this message
Michael Bienia (geser) wrote :

As I find the table from the first example easier to read (the fields are clearer seperated) than the list view from example two and the box from example three making it more obvious that it's an "extra" and not part of the page itself, what about a mix of example 1 and 3 (a table inside the blue box)?

I've prepared a mockup of it.

Revision history for this message
Julian Edwards (julian-edwards) wrote : Re: [Bug 280958] Re: Package page doesn't show PPAs for that package

I still prefer #3 personally. Can you put a table inside the informational
message?

Revision history for this message
Julian Edwards (julian-edwards) wrote : Re: Package page doesn't show PPAs for that package

Ummm that should have been #4! I can't count, obviously.

Revision history for this message
Michael Nelson (michael.nelson) wrote : Re: [Bug 280958] Re: Package page doesn't show PPAs for that package

-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

Michael Bienia wrote:
> As I find the table from the first example easier to read (the fields
> are clearer seperated) than the list view from example two and the box
> from example three making it more obvious that it's an "extra" and not
> part of the page itself, what about a mix of example 1 and 3 (a table
> inside the blue box)?
>
> I've prepared a mockup of it.
>
> ** Attachment added: "bug-280958-mockup-table_with_fade_highlight_eg.png"
> http://launchpadlibrarian.net/28417522/bug-280958-mockup-table_with_fade_highlight_eg.png
>

Thanks for the mockup Michael! So, from your feedback and Julian's, it
seems that using #4 (the box with border and icon) with the table inside
of it is the clearest...

Martin, do you agree?

(IMO, I do find the table version easier to read, but it seems then to
be more important information on the page - ie. similar to the table
above it... so I'm undecided :) ).

- --
Michael
-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.9 (GNU/Linux)
Comment: Using GnuPG with Mozilla - http://enigmail.mozdev.org

iEYEARECAAYFAkpE6EwACgkQGSan/irvan2wowCghztbLC361zHi7NkQfN/EC85n
zsQAn0oQbC/RC2Q4+gxhkncexJA3vznR
=Bp92
-----END PGP SIGNATURE-----

Revision history for this message
Scott Kitterman (kitterman) wrote : Re: [Bug 280958] Re: Package page doesn't show PPAs for that package

I like the visual distinction. It addresses part of my concern about
distinguishing between what's in the distro and what's not.

The word "unsupported" though is, I believe, completely inadequate.

In distro terms, Universe is unsupported.

These PPAs can up created by any unknown third party so there is (without
looking into a specific PPA to see who has access to it) no guarantee of
anything about the code. There's no basis for trust at all.

Revision history for this message
Julian Edwards (julian-edwards) wrote : Re: [Bug 280958] Re: Package page doesn't show PPAs for that package

On Friday 26 June 2009 16:25:05 Michael Nelson wrote:
> (IMO, I do find the table version easier to read, but it seems then to
> be more important information on the page - ie. similar to the table
> above it... so I'm undecided :) ).

That's exactly my concern as well.

However, I feel that this extra information is less important than the
official Ubuntu package so while it should be very readable, it should not
dominate the page.

Revision history for this message
Martin Albisetti (beuno) wrote : Re: Package page doesn't show PPAs for that package

Agreed. I think we should say "untrusted" as well, and make it less flashy.
Will recommend changes on the merge proposal.
Thanks Scott for the input.

Revision history for this message
Matthew Paul Thomas (mpt) wrote :

Please don't use the notification color or border style for something that isn't a notification. It's misleading (and also unattractive, because it makes one table slightly narrower than the others on the page). If you want to signal possible danger, you could use an icon with the section's introductory sentence. (Or maybe just "Untrusted", as Martin suggests, would be enough.)

Michael, now that I see your mockups, I notice a flaw in my initial suggestion. :-) The "Version history" is the history of the versions published in the distribution, not of any versions published in PPAs, correct? If so, it's inappropriate for the list of PPA versions to separate those sections. A simple way to fix this would be to move the PPA packages section after the version history.

Revision history for this message
Michael Bienia (geser) wrote :

Yes, the "Version history" is for the uploads to Ubuntu's main archive. Moving the PPA packages to end of the page would hold the version table and the version history together but also make the PPA list/table nearly undiscoverable as the version history can be rather long for some packages (e.g. https://edge.launchpad.net/ubuntu/+source/linux) and a link to the PPA list/table would be needed (as I doubt that it would be found otherwise).
This would also have that advantage that it wouldn't mix so easily with the "official" versions as it wouldn't be at the top of the page anymore. Nonetheless it should be made clear that this PPA versions table is only informational and the packages linked are untrusted (or whatever word it will finally be). I don't know what is intended for this kind of information in the LP style guide.

Revision history for this message
Julian Edwards (julian-edwards) wrote :

Regarding discoverability versus inappropriate placement, we also discussed leaving it where it is, but having a section open up via a Javascript action.

My opinion is that putting it at the bottom of the version history is potentially far worse than splitting up the version table and the version history because it just won't get seen for anything with even a small history. Can anyone think of any other layouts where it wouldn't disappear from the top of the page, yet not split those two?

Revision history for this message
Diogo Matsubara (matsubara) wrote : Bug fixed by a commit

Fixed in devel r8721.

Changed in soyuz:
status: In Progress → Fix Committed
Revision history for this message
Martin Albisetti (beuno) wrote : Re: Package page doesn't show PPAs for that package

What landed???
This was *not* ready to land.

Revision history for this message
Michael Nelson (michael.nelson) wrote :

Hey Martin, I realise that you're super-busy at the moment, so when on Friday you commented here (about using "untrusted" - https://bugs.edge.launchpad.net/soyuz/+bug/280958/comments/24) and said that you'd recommend changes on the MP, I waited until Monday but then, knowing how busy you are I discussed the issue with Julian and Celso and landed it on Edge with ui=rs. Our reasons were that (1) it is very early in the cycle, so there is lots of time to tweak the change, (2) seeing the functionality with real data would be very helpful here, and (3) it's not fun context-switching back and forth from this bug with an in-progress branch while trying to get other things done. (And as fate would have it, just after submitting the branch to ec2test to land, mpt left a new comment :) ).

Perhaps in retrospect I should have updated dogfood instead, but that was the decision we made together. If it was a wrong one and you want it backed out, I can land a reversal today and we'll have learned something for the future :) (the change is not yet on edge).

Either way, the landing was *not* meant to close this bug as fix-committed, as if to end the discussion - that was just the automatic script.

Changed in soyuz:
status: Fix Committed → In Progress
Revision history for this message
Michael Nelson (michael.nelson) wrote :

I wrote above:
> I discussed the issue with Julian and Celso and landed it on Edge with ui=rs

after updating the wording to use "untrusted" of course.

description: updated
Revision history for this message
Matthew Paul Thomas (mpt) wrote :

Michael, you're right, I should have looked at my own example! "PPAs for fast-user-switch-applet" would be completely lost at the bottom of <https://launchpad.net/ubuntu/+source/fast-user-switch-applet>. Probably the version history should be a table where each row is collapsed by default, but for a package with a long history like this one, even that wouldn't help much.

Maybe we can alleviate the order problem with more precise headings:

    = “fast-user-switch-applet” source package in Ubuntu =

    == Versions published in Ubuntu series ==
    ...

    == Untrusted versions in PPAs ==
    ...

    == History of versions published in Ubuntu ==
    ...

Anything more than that is probably veering into major redesign territory. (Perhaps the "Published versions", "Version history", and "Source package publishing history" tables should be combined into a single expandable table...)

Revision history for this message
Michael Nelson (michael.nelson) wrote :

Matthew, I think the above headings would help *if and only if* the "Untrusted versions in PPAs" information was information that really 'belonged' on this page, as opposed to additional related information. As it is, at least to me, the above headings give the impression that the "Untrusted versions in PPAs" are just as relevant as the other level-two headings.

Which is why I still prefer something along the lines of:

http://launchpadlibrarian.net/28417295/bug-280958-4-with-border-and-ppa-icon.png

(with the additional 'untrusted' wording), because it implies that it is additional related information, rather than core information related to the distribution source package. Scott seemed to think so too (see above).

We could easily collapse the PPA information by default, ie:

> See related PPA versions (when you click it drops down displaying the above).

And of course, background colours and borders are simple style changes if you have recommendations. Please let me know your thoughts...

As I mentioned previously, I do think that Michael's mockup using a table is easier to read, but think it also nudges it back to looking as important as the versions published in Ubuntu, at least to me.

Looking forward to finalising this ui change! (And yes, I also agree that we need to stick to a design that is achievable now, rather than a major redesign).

Revision history for this message
Scott Kitterman (kitterman) wrote : Re: [Bug 280958] Re: Package page doesn't show PPAs for that package

Would it be possible to see a mockup of this?

Revision history for this message
Michael Nelson (michael.nelson) wrote : Re: Package page doesn't show PPAs for that package

Yup, good idea Scott... here is the current version that will be rolled out on edge tonight.

Bear in mind that it is an initial version to be worked further with more feedback and comments etc.

Revision history for this message
Martin Albisetti (beuno) wrote :

I've been playing a little bit, and here's an alternative version attached.
While Michael's version as landed, it's not the final one and we're mostly experimenting on how to deal with such a delicate issue.

Revision history for this message
Julian Edwards (julian-edwards) wrote : Re: [Bug 280958] Re: Package page doesn't show PPAs for that package

On Tuesday 30 June 2009 22:26:49 Martin Albisetti wrote:
> I've been playing a little bit, and here's an alternative version attached.
> While Michael's version as landed, it's not the final one and we're mostly
> experimenting on how to deal with such a delicate issue.

I only have a couple of points:

 1. You know that PPA icon I badgered you about for ages....it's missing ;)
 (Michael used it in his change and I think it really helps identify and brand
PPAs, I'd like to have it used more consistently wherever we have PPA-related
things.)

 2. There's a massive white space on the left. It's pretty ugly :(

Revision history for this message
Martin Albisetti (beuno) wrote :

On Tue, Jun 30, 2009 at 6:58 PM, Julian
Edwards<email address hidden> wrote:
>  1. You know that PPA icon I badgered you about for ages....it's missing ;)
>  (Michael used it in his change and I think it really helps identify and brand
> PPAs, I'd like to have it used more consistently wherever we have PPA-related
> things.)

Missing?
It's on each row! :)

>  2. There's a massive white space on the left.  It's pretty ugly :(

I know. The reason for this so so it doesn't look like part of the
content, which it's not. So it's not terribly beautiful, but it allows
packagers to ignore it pretty easily.
I couldn't find a better way of doing this, but suggestions are
welcome (or begged for!).

Revision history for this message
Scott Kitterman (kitterman) wrote : Re: [Bug 280958] Re: Package page doesn't show PPAs for that package

One other thought I have is that there ought to be some discussion about
what we mean by untrusted and why users should care. Perhaps a hyperlink
to a static page from the word untrusted.

Revision history for this message
Michael Nelson (michael.nelson) wrote : Re: Package page doesn't show PPAs for that package

Scott, good point... perhaps something like the new help links on the PPA pages? (see https://edge.launchpad.net/~cprov/+archive/ppa)

Martin, thanks for taking the time to express your thoughts with a branch... very helpful. So my thoughts:

+1 for the wording changes.

I think the tweaks to the wording that you've made are all good decisions.

+0 for linkifying the owners

I think this looks better, but thought that during our pre-imp. we had decided against linking anything more than the PPA as all the other information is on the PPA. That said, I can imagine wanting to know who the owner is *before* I click on their PPA.

-0 for the repeated small PPA icons rather than the single PPA branding

IMO, the small PPA icons help to differentiate a list of mixed information (ie. on a persons profile page where PPAs, bugs and blueprints are all displayed in the same area etc.). I thought the single larger icon identified the whole block of information as PPA related.

-0 for not bringing the information "off the page" somehow (border or background)

I realise that the border colours/background that I used might leave it looking too similar to an informational message/error message, but I do think that something similar needs to be done. As it is in your mockup, it looks to me like it is information *about* the context of the page, rather than additional related information that is not about the context of the page. I thought that was the main concern of Scott's that we were trying to address.

As it is, it seems Edge hasn't been updated (it's still on r8720), so there's still time to update my changes before they hit Edge :)

Revision history for this message
Julian Edwards (julian-edwards) wrote : Re: [Bug 280958] Re: Package page doesn't show PPAs for that package

> Missing?
> It's on each row! :)

Haha! I meant the big one! :)

> > 2. There's a massive white space on the left. It's pretty ugly :(
>
> I know. The reason for this so so it doesn't look like part of the
> content, which it's not. So it's not terribly beautiful, but it allows
> packagers to ignore it pretty easily.
> I couldn't find a better way of doing this, but suggestions are
> welcome (or begged for!).

I think the only way you can make it not look really like part of the main
content is to make it a portlet. Or put a border around it like Michael did.

Other things that come to mind are:
 * Make its font smaller
 * Wrap it inside either the version table (which is massive)
 * Wrap it inside the history
 * Make it take up less space on the screen.

The portlet solution is slighly controversial and awkward because Launchpad is
moving away from using portlets (which many don't like, and I personally think
it only works well on some pages. not all).

The solution that Michael did was, I thought, pretty good in that it made
several visual distinctions and it really didn't look like the main content
nor wasn't too ugly.

Revision history for this message
Julian Edwards (julian-edwards) wrote :

On Tuesday 30 June 2009 23:36:35 Scott Kitterman wrote:
> One other thought I have is that there ought to be some discussion about
> what we mean by untrusted and why users should care. Perhaps a hyperlink
> to a static page from the word untrusted.

Yes, I like this idea.

Revision history for this message
Julian Edwards (julian-edwards) wrote :

> Other things that come to mind are:
> * Make its font smaller
> * Wrap it inside either the version table (which is massive)
> * Wrap it inside the history
> * Make it take up less space on the screen.

One more:

 * Make the section default to a collapsed row which reads something like:

 "This source is also available in N PPAs"

   and clicking on the row expands it to the full list.

Revision history for this message
William Grant (wgrant) wrote : Re: Package page doesn't show PPAs for that package

I don't think the PPA listing belongs on that page, if only because it is going to get horrendously long in many cases. I'd suggest links (with the beloved PPA icon, naturally) to a new SP:+ppas next to each series in the publishing table. The links would need some succinct text to draw user attention to them, or perhaps a line or two about them under the table.

That would keep them unobtrusive but not terribly unobvious. SP:+ppas could then easily be covered with terrifyingly verbose warnings about untrustedness, without having to worry about space on DSP:+index.

Revision history for this message
William Grant (wgrant) wrote :

The collapsing suggestion that Julian made while I was writing that comment would work too, but it isn't as helpful if I'm running Dapper. I think separating the list by series makes quite a bit of sense. I'd be happy with either, though.

Revision history for this message
Matthew Paul Thomas (mpt) wrote :

Besides the interesting use of whitespace, Martin's proposal has the same general drawback as the previous mockups: it results in the same type of information being presented, on the same page, in two different ways. The version number is shown in one way in the published versions section, and a different way in the PPA packages section. And the distribution series name is shown in one way in the published versions section, and a different way in the PPA packages section. The sections do present some different data too, for good reason, but a good design would present these different things (and convey untrustedness for PPA packages) in a way that maintains visual consistency in what the sections have in common. For example, the Version column in the PPA packages table should line up *exactly* with the Version column in the published versions table.

One simple way of making PPA packages look slightly foreign, besides using different icons, would be to give the whole PPA packages table a light grey background.

Revision history for this message
Julian Edwards (julian-edwards) wrote : Re: [Bug 280958] Re: Package page doesn't show PPAs for that package

On Wednesday 01 July 2009 10:17:10 Matthew Paul Thomas wrote:
> One simple way of making PPA packages look slightly foreign, besides
> using different icons, would be to give the whole PPA packages table a
> light grey background.

This is exactly what Michael has done in his most recent change (which
unfortunately is not on edge since it failed to update last night).

Revision history for this message
Michael Nelson (michael.nelson) wrote : Re: Package page doesn't show PPAs for that package

Hi Matthew,

If each PPA displayed should only occupy 1 row or list item (whichever is best), but at the same time, should display the multiple versions in the different distroseries published in that PPA (as in the mockup http://launchpadlibrarian.net/28549058/bug-280958-5-with-border-and-icon-untrusted.png), then I'm not sure how they *could* be presented the same, with the versions lining up. Thoughts?

Also, Michael Bienia helpfully provided an example with data displayed as a table rather than a list (scroll up)... my feeling was that although it did improve the look, it also seemed to re-establish the information as on-par with the distribution versions in terms of relevance (take a look and see what you think). That's why I used a simple list in the link above - the point being to distinguish it as co-incidental information.

Revision history for this message
Julian Edwards (julian-edwards) wrote : Re: [Bug 280958] Re: Package page doesn't show PPAs for that package

On Wednesday 01 July 2009 10:01:57 William Grant wrote:
> I don't think the PPA listing belongs on that page, if only because it
> is going to get horrendously long in many cases. I'd suggest links (with
> the beloved PPA icon, naturally) to a new SP:+ppas next to each series
> in the publishing table. The links would need some succinct text to draw
> user attention to them, or perhaps a line or two about them under the
> table.

-1 from me

It diminishes the usefulness quite a lot to need an extra page load all the
time. As Michael said on IRC, we only want to present the top 3 anyway, with
a link to more if you want.

Revision history for this message
Michael Nelson (michael.nelson) wrote : Re: Package page doesn't show PPAs for that package

And regarding William's comment:

<noodles775> wgrant: the ppa listing is just a snippet (ie. only 3 archives with the latest publishings)
<wgrant> noodles775: Well, that's pretty useless.
<wgrant> noodles775: What's the point of it?
<noodles775> wgrant: with a link to further ones of course...
<wgrant> noodles775: Ah.
<wgrant> That's eventually always going to be dailies in a lot of cases, so I still don't like it much.
<noodles775> wgrant: as in the bug, the long-term plan is to (1) have the top *ranked* ones displayed there,
<noodles775> wgrant: and (2) eventually have the link going to a better page than the ppa search.
<wgrant> noodles775: I might read the bug again... there's been a few comments, so I've probably forgotten everything.
<noodles775> wgrant: yeah, it'd be great to get more feedback from people! Thanks!

description: updated
summary: - Package page doesn't show PPAs for that package
+ Package page doesn't show related PPAs for that package
description: updated
Revision history for this message
Michael Bienia (geser) wrote :

When I look again at the current proposals linked in the description and first just look at the presentation of the information it wants to convey then both the table layout and the two-line items (ppas-in-packages.png) make the data easy to read. The items in bug-280958-5-with-border-and-icon-untrusted.png make it hard to find where one piece of infomation ends and the next one starts. This is much better solved in the two-line items proposal as the PPA name and the owner are seperated by some non-linked text (and therefore different color) and the icons before the links itself. Moving the version list into the second item completes it then.

Looking at the integration of the data into the page itself:
- ppas-in-packages.png: nice idea but the right-align of the data looks at at first glance like a display/positioning error to me (too much whitespace left of the data)
- thinking about the boxes from the other proposals again I get slowly the impression that it gets that way too much emphasis than it's really intended and moves it more into the foreground instead of background.

As this PPA infomation is more a side-note in the context of this page, it would be good to place it at the side (but it's already used by the portlets). ppas-in-packages.png seems to try to do it by right-aligning the data (but not really successfull).

Revision history for this message
Michael Nelson (michael.nelson) wrote :

Thanks for the feedback Michael.

Yep, I agree that the wording and spacing of the text in ppas-in-packages.png is much clearer.

I wonder if your main concern - too much emphasis - would be addressed by the suggested collapsing of the information by default (so it requires a click to display it)? And if you can think of any other ways we could indicate visually that it is supplementary info, let me know!

And yes, I agree that the side would be the most appropriate place for this information, but when we discussed it previously we could not find a way to present it with such a limited width. It's seems necessary to include the name of the PPA, the owner and the versions... which is very difficult in the sidebar.

Revision history for this message
Michael Bienia (geser) wrote :

Yes, I guess a collapsed view as default would be nice as the data needs some space as can already be seen in the proposals (and it only shows two PPAs instead of the proposed max of three PPAs).

I've once again played a little bit with gimp and took ppas-in-packages.png as a base, moved the data more to the left but kept it still indented (perhaps the box in my mockup should look centered (made wider)) and added the blue (i) icon (which is hopefully recognized by most for "information") to it.
I also surrounded it by a box but I'm not sure if the box should be filled in grey (as there would be too much grey at the first "page" like in bug-280958-5-with-border-and-icon-untrusted.png). Filling the box with an other colour would perhaps make it too visible, so it should be filled with a slight grey if at all.

description: updated
Revision history for this message
Martin Albisetti (beuno) wrote : Re: [Bug 280958] Re: Package page doesn't show PPAs for that package

So, I think that adding a border around it, aligning it to the left,
or adding a background color, will draw more attention to it than the
rest of the content. This is the opposite of what we want.

At this point, I'm inclined to say the best solution is to have a very
discreet mention to the PPAs ("> Other versions in untrusted personal
archives"), and have it expand the information.

This has proven to be a hard issue to solve without plain-out
redesigning the whole page, as Matthew mentions.

Revision history for this message
Scott Kitterman (kitterman) wrote : Re: [Bug 280958] Re: Package page doesn't show related PPAs for that package

Would it make sense to defer this until after PPA ranking is available?

Revision history for this message
Michael Nelson (michael.nelson) wrote :

Martin: Great... I'll implement the changes today and add screenshots. The previous version landed on edge last night - and I'm looking forward to the versions looking much neater!

Scott: It's worth thinking about. Personally I think it is still worthwhile the way it is, as usually the most recently uploaded versions will be from official nightly builds etc. The ranking will certainly improve the results (making them consistent over time, rather than simply the most recently uploaded).

Revision history for this message
Michael Nelson (michael.nelson) wrote :

Scott: I was just chatting with Julian, and given that the current order *might* imply a rank that doesn't exist yet, we'll explicitly state that those displayed are the most recent uploads.

Perhaps adapting Martin's expander text to:

"> Most recent versions in untrusted personal archives"

or

"> Most recent versions uploaded to untrusted personal archives"

Revision history for this message
Michael Nelson (michael.nelson) wrote :

Here's a quick video that demonstrates the drop-down with Martin's layout. Note, the info does actually slide down and up nicely... the video quality makes it appear as though it doesn't slide.

Martin, let me know any wording changes etc., and I'll try to get it on edge tonight (if it is what you were after).

Revision history for this message
Martin Albisetti (beuno) wrote : Re: [Bug 280958] Re: Package page doesn't show related PPAs for that package

On Thu, Jul 2, 2009 at 8:00 AM, Michael
Nelson<email address hidden> wrote:
> Martin, let me know any wording changes etc., and I'll try to get it on
> edge tonight (if it is what you were after).
>
> ** Attachment added: "ppas-in-packages.ogv"
>   http://launchpadlibrarian.net/28624082/ppas-in-packages.ogv

I think this looks good! I'd change the expander text to "Other
versions of mozilla-firefox in untrusted archives". You can explain
the criteria for which they where selected inside the expanded text:
"Most recently updated unsupported and....".

I agree with Scott that ideally we would do this after we've figured
out how to do PPA rankings, but that discussion is a long one, and
getting out feet wet and having some experience will help us have that
discussion with more information.

ui=bueno from me, thanks for all the hard work Michael, I know this
was especially hard :)

--
Martin

Revision history for this message
Julian Edwards (julian-edwards) wrote : Re: [Bug 280958] Re: Package page doesn't show related PPAs for that package

> ui=bueno from me, thanks for all the hard work Michael, I know this
> was especially hard :)

Ditto from me.

One question though, how does it degrade when the browser has JS disabled?

Revision history for this message
Michael Nelson (michael.nelson) wrote :

Thanks Julian,

If JS is disabled:

1) the information is expanded (as there would be no way to view it otherwise),
2) there is no toggle icon.
3) the header sentence does not have the js-action class and so isn't styled like a clickable link.

Revision history for this message
Fabien Tassin (fta) wrote :

I have a problem with this whole "Most recent versions uploaded" concept.

I'll try to explain with my own experience..

I maintain a lot of packages in different PPAs, including firefox-3.5 (which is in karmic too; this is what led me to this bug).

Some people like to copy/rebuild my packages to their own PPA (i don't fully understand why but it's a fact), so their packages are "more recent" than mine, even if they have no added value, and are in PPAs clearly advertised as for private use only.

2 days ago, when firefox 3.5 was officially released, the whole community was looking for debs for their distro (mostly for jaunty and hardy) as we (the ubuntu mozilla team) only pushed it to karmic (so far [*]), and to PPAs.

I had a look at Launchpad yesterday, it presented 3 obscure PPAs, all incomplete and/or broken, neither the team PPAs nor mine were presented, clearly leading to confusion. All 3 were rebuilds with a new version in changelog, but without any change.

I received a lot of emails & dents (identica) asking me to clarify the firefox 3.5 situation (/wrt [*]), the new LP page is obviously not the source of those (as it's new) but it's a potential source of even more confusions in the future.

If not sorted by rank, the list of PPAs should show the last changelog entry, and possibly the PPA board, or something.

Revision history for this message
Michael Nelson (michael.nelson) wrote :

Hi Fabien,

Yep, your problem is obviously completely valid. From the start of this bug we've said that 'most recently uploaded' is just the best we can do in the absence of a rank of some sort. Although we chatted about the issues, we may not have realised how badly it would impact people.

If we can't find something to deal with this issue in the next few days, we may need to pull it off edge before the end of this cycle. One possibility is that we add the rank field now and manually set it until the user-ranking is setup... but that could have its own problems :)

Thanks for the feedback.

Revision history for this message
Scott Kitterman (kitterman) wrote : Re: [Bug 280958] Re: Package page doesn't show related PPAs for that package

This most recent discussion about Firefox highlights some of why I have
serious concerns about this change. As it has evolved, it has improved,
but fundamentally I think it's not a good idea.

Revision history for this message
Michael Nelson (michael.nelson) wrote :

Scott, yes, without ranking it may be that in its current state it is not worth the grief it may cause people like Fabien.

I'm trying to land the new version on edge tonight that will clearly state that the ppas displayed are just the ones with the most recently uploaded packages (as I understand it, that was part of the confusion for Fabien's users), so maybe we can evaluate then if it should be removed completely for the moment?

Another thought I had for an intermediate solution is whether we could:

1) Check if the upstream project has a team PPA with the source published (in this case https://edge.launchpad.net/~mozillateam), and if so, present those publishings, otherwise
2) default to latest upload.

Revision history for this message
Fabien Tassin (fta) wrote :

Michael, I'm afraid it's not that easy. For example, for the mozillateam, we would like to see
https://edge.launchpad.net/~ubuntu-mozilla-security/+archive/ppa and
https://edge.launchpad.net/~ubuntu-mozilla-daily/+archive/ppa listed.
We also have a team ppa but it's no longer maintained, for some reasons.
The 2 PPAs above are not *linked* to ~mozillateam, yet they have common members/owners.

This means we need a way to tag authoritative PPAs, maybe from a team or project page.
Another idea could be to check that PPAs found by the search engine are owned by at least one member of the project/team.

Revision history for this message
Diogo Matsubara (matsubara) wrote : Bug fixed by a commit

Fixed in devel r8771.

Changed in soyuz:
status: In Progress → Fix Committed
Revision history for this message
Michael Nelson (michael.nelson) wrote :

Sorry... the auto-script updated the status with the commit (my fault). So the new version is now committed, but won't be through our buildbot test for another 8hours or so. I'll see if we can get edge updated as soon as that happens.

Fabien: thanks for the suggestion... I'll try it today.

Changed in soyuz:
status: Fix Committed → In Progress
description: updated
Revision history for this message
William Grant (wgrant) wrote :

Fabien, there is no such thing as an authoritative PPA. PPAs are by definition not authoritative. Any attempt to add a feature to mark some as more official is wrong.

Revision history for this message
Michael Nelson (michael.nelson) wrote :

Hey William,

Yes, 'authoritative' is not the right word, but I'm guessing that Fabien didn't mean the "one true source", but simply "the one(s) that users are probably wanting to find".

Ranking would allow this to be user-determined, but until we have ranking, do you have any other ideas for another intermediate alternative?

Revision history for this message
William Grant (wgrant) wrote :

"the one(s) that users are probably wanting to find" suffers from the same problem. From which perspective? The only reasonable way to display them is using some calculated ranking, probably by number of users.

Revision history for this message
Michael Nelson (michael.nelson) wrote :

Earlier today Fabien, Julian, William and I were chatting and Fabien came up with the idea of just using what we've got in terms of karma to sort the resulting archives.

I didn't get a chance to finish it today, but have taken a look, and it should be straight-forward to sort the results by the karma of the uploader... which should drastically improve the randomness of the quality of the three top archives displayed. Thanks Fabien!

Revision history for this message
Michael Nelson (michael.nelson) wrote :

With r8793 (not yet on edge) the related archives are sorted by (I hope this makes sense!) the soyuz-specific karma for the specific package name of the creator of the source package release. Furthermore, there is a minimum of 20 karma points (soyuz-specific for that package) required to be displayed at all.

So, people who have uploaded the FF3.5 package and are maintainers and/or listed as the changed_by, should have more soyuz karma for that package and be displayed before others who randomly upload FF3.5 package.

We will still have to evaluate how this works in practice with real day-to-day use on edge. We can tweak the minimum required karma points for the package too.

Changed in soyuz:
status: In Progress → Fix Committed
Revision history for this message
Robert Collins (lifeless) wrote : Re: [Bug 280958] Re: Package page doesn't show related PPAs for that package

I like this. I'm curious why you required soyuz specific karma though.
E.g. the bzr upstream ppa should really be shown against bzr packages,
and our devs have huge karma upstream, even though we don't upload as
many things as e.g. a full time ubuntu dev....

-Rob

Revision history for this message
Michael Nelson (michael.nelson) wrote :

Thanks Rob - it's been a huge collaborative effort as you can see in the comments.

The reason for using soyuz-specific karma is that it is the easiest - we can use it in the query via a single join without any aggregations etc., This is because we have a KarmaCache (updated daily) which stores a person's total karma for a particular karma category ('soyuz'), distribution and package name.

If it makes more sense to favour devs for these related PPAs, we could instead use the 'code' karma category and order by the person's total code-karma for the product/project? (still without doing aggregates etc.)

And finally, if it was worthwhile and we had a good heuristic, we could *try* to use some kind of aggregate (sum/avg?) of karma across multiple categories, but that will require quite an ugly query (due to the different ways karma can be recorded - against packages/projects/products).

Either way, we'll still need to watch the current ordering over the next few days - it might favour people who regularly grab FF3.5 and upload it to their own PPA too strongly.

Revision history for this message
Julian Edwards (julian-edwards) wrote :

Rob, it makes more sense just to use Soyuz karma for now as that is the most
directly appropriate category in most cases, i.e. if someone is uploading a
package repeatedly then it's quite likely to be useful. We plan on adding
more ranking features in the future.

Changed in soyuz:
status: Fix Committed → Fix Released
To post a comment you must log in.
This report contains Public information  
Everyone can see this information.

Duplicates of this bug

Other bug subscribers